package gridslab;

import javax.servlet.http.*;
import org.apache.struts.action.*;
import java.util.*;
import javax.naming.*;
import javax.naming.directory.*;


public final class ListJobManagersAction extends Action {

  private static String man_context = "Mds-Vo-name=local,o=grid";
  private static String man_filter = "(Mds-Software-deployment=jobmanager*)";
  private static String[] man_attributes = {
         "Mds-Software-deployment",
         "Mds-Service-Gram-schedulertype",
         "Mds-Service-protocol"
  };

  private static String q_filter = "(Mds-Job-Queue-name=*)";
  private static String[] q_attributes = {
         "Mds-Job-Queue-name",
         "Mds-Gram-Job-Queue-dispatchtype",
         "Mds-Computer-Total-nodeCount",
         "Mds-Computer-Total-Free-nodeCount"
  };



  public ActionForward perform(ActionMapping mapping,
                             ActionForm form,
                             HttpServletRequest request,
                             HttpServletResponse response) {


    ListJobManagersForm ljmf = (ListJobManagersForm) form; // get the form bean

    // get form info which should be a Location.
    String address = ljmf.getAddress();
    String heading = ljmf.getHeading();

    GridbusDirectory gbd = new GridbusDirectory();

    Attributes man_attrRes;
    Attribute man_attr;
    SearchResult man_sr;
    NamingEnumeration man_nameEnum;
    Attributes q_attrRes;
    Attribute q_attr;
    SearchResult q_sr;
    NamingEnumeration q_nameEnum;

    JobManager jm = new JobManager();
    Vector managers = new Vector();
    JobQueue jq = new JobQueue();
    Vector queues = new Vector();

    try {
        boolean online = gbd.bind("ldap://" + address);
        man_nameEnum = gbd.search(man_context, man_filter, man_attributes, 0);

        if (man_nameEnum != null && online) {
            while (man_nameEnum.hasMore()) {
                man_sr = (SearchResult)man_nameEnum.next();
                man_attrRes = man_sr.getAttributes();
		//sets the dn.
		jm = new JobManager(man_sr.getName() + "," + man_context);

		man_attr = extractAttribute(man_attrRes, man_attributes[0]);
		if (man_attr != null) {
                	jm.setName((String) man_attr.get());
		}

		man_attr = extractAttribute(man_attrRes, man_attributes[1]);
		if (man_attr != null) {
			jm.setSchedType((String) man_attr.get());
		}

		man_attr = extractAttribute(man_attrRes, man_attributes[2]);
		if (man_attr != null) {
			jm.setProtocol((String) man_attr.get());
		}

		//add queues//

        	q_nameEnum = gbd.search(jm.getDn(), q_filter, q_attributes, 0);

        	if (q_nameEnum != null && online) {
            		while (q_nameEnum.hasMore()) {
                		q_sr = (SearchResult)q_nameEnum.next();
                		q_attrRes = q_sr.getAttributes();
                		jq = new JobQueue();

                		q_attr = extractAttribute(q_attrRes, q_attributes[0]);
                		if (q_attr != null) {
                        		jq.setName((String) q_attr.get());
                		}

                		q_attr = extractAttribute(q_attrRes, q_attributes[1]);
                		if (q_attr != null) {
                        		jq.setDispType((String) q_attr.get());
                		}

                		q_attr = extractAttribute(q_attrRes, q_attributes[2]);
                		if (q_attr != null) {
                        		jq.setTotalNodes(Integer.parseInt((String) q_attr.get()));
                		}

                		q_attr = extractAttribute(q_attrRes, q_attributes[3]);
                		if (q_attr != null) {
                        		jq.setTotalNodesFree(Integer.parseInt((String) q_attr.get()));
                		}

                		jm.addQueue(jq);
            		}
        	}

		managers.add(jm);
            }
        }

	gbd.unbind();

    } catch (Exception e) {
        e.printStackTrace();
    }

    request.setAttribute("managers", managers);
    request.setAttribute("address", address);
    request.setAttribute("heading", heading);

    // Forward control to the specified success target
    return (mapping.findForward("success"));
  }

  private static Attribute extractAttribute(Attributes attrs, String attrName) {
      return attrs.get(attrName);
  }
}

