package gridslab;

import javax.servlet.http.*;
import org.apache.struts.action.*;
import java.util.*;
import javax.naming.*;
import javax.naming.directory.*;


public final class ListJobQueuesAction extends Action {

  private static String filter = "(Mds-Job-Queue-name=*)";
  private static String[] attributes = {
         "Mds-Job-Queue-name",
	 "Mds-Gram-Job-Queue-dispatchtype",
         "Mds-Computer-Total-nodeCount",
         "Mds-Computer-Total-Free-nodeCount"
  };


  public ActionForward perform(ActionMapping mapping,
                             ActionForm form,
                             HttpServletRequest request,
                             HttpServletResponse response) {


    ListJobQueuesForm ljqf = (ListJobQueuesForm) form; // get the form bean

    String dn = ljqf.getDn();
    String address = ljqf.getAddress();
    String heading = ljqf.getHeading();

    GridbusDirectory gbd = new GridbusDirectory();
    Attributes attrRes;
    Attribute attr;
    SearchResult sr;
    NamingEnumeration nameEnum;
    JobQueue jq = new JobQueue();
    Vector queues = new Vector();

    try {
        boolean online = gbd.bind("ldap://" + address);
        nameEnum = gbd.search(dn, filter, attributes, 0);

        if (nameEnum != null && online) {
            while (nameEnum.hasMore()) {
                sr = (SearchResult)nameEnum.next();
                attrRes = sr.getAttributes();
		jq = new JobQueue();

		attr = extractAttribute(attrRes, attributes[0]);
		if (attr != null) {
                	jq.setName((String) attr.get());
		}

		attr = extractAttribute(attrRes, attributes[1]);
		if (attr != null) {
			jq.setDispType((String) attr.get());
		}

		attr = extractAttribute(attrRes, attributes[2]);
		if (attr != null) {
			jq.setTotalNodes(Integer.parseInt((String) attr.get()));
		}

		attr = extractAttribute(attrRes, attributes[3]);
		if (attr != null) {
			jq.setTotalNodesFree(Integer.parseInt((String) attr.get()));
		}

		queues.add(jq);
            }
        }

	gbd.unbind();

    } catch (Exception e) {
        e.printStackTrace();
    }

    request.setAttribute("queues", queues);
    request.setAttribute("heading", heading);

    // Forward control to the specified success target
    return (mapping.findForward("success"));
  }

  private static Attribute extractAttribute(Attributes attrs, String attrName) {
      return attrs.get(attrName);
  }
}

